require "prefabutil"--Используемые части
require "recipe"-- Если бы я знал что это, я бы оставил себе хитрое помечание
require "modutil"-- Но я либо не знаю, либо помечание слишком хитрое

local assets=
{
    Asset("ANIM", "anim/waterbarrle.zip"),-- В папке anim должен быть архив с чем то, с чем - узнаю потом 
	Asset("ATLAS", "images/inventoryimages/beer_barrle.xml"),
}

--------------------------------

----------------------------------

local hmele = 0

local function onhammered(inst, worker)
	inst.components.lootdropper:DropLoot()
	if inst.components.container ~= nil then
		inst.components.container:DropEverything()
	end
	local fx = SpawnPrefab("collapse_big")
	fx.Transform:SetPosition(inst.Transform:GetWorldPosition())
	fx:SetMaterial("wood")
	inst:Remove()
end

local function onhit(inst, worker)
--print(test)
end

local function addbrew(inst)
	if inst.wait==0 then
	    inst.wait=inst.wait+TUNING.BEER_WAIT
	    inst.wheat=inst.wheat-3
		inst.waterlevel=inst.waterlevel-3
		inst.beer=inst.beer+5
	end
	if inst.waterlevel>2 and inst.wheat>2 then
	    inst.wait=inst.wait-1
	end
end

local function checkstatusdon(inst)
	if inst.components.container:GetItemInSlot(1) == "berries_juicy" then
		inst.components.container:Close()
		inst.components.container:DestroyContents()
	end
if inst.components.talker then
    if inst.waterlevel<3 and inst.beer==0 then
	    inst.components.talker:Say("  Water "..inst.waterlevel.."/3 . Add water!")
	end
	if inst.waterlevel==3 and inst.wheat<3 and inst.beer==0 then
	    inst.components.talker:Say("  Wheat "..inst.wheat.."/3 . Add wheat!")
	end
    if inst.wait<TUNING.BEER_WAIT-1 and inst.waterlevel==3 and inst.beer==0 and inst.wheat==3 then
	    inst.components.talker:Say("  Time: "..inst.wait.." minutes")
	end
	if inst.beer~=0 then
	    inst.components.talker:Say("  Beer "..inst.beer.."/5")
	end
end
end

local function ShouldAcceptItem(inst, item, giver)
	if item.prefab == ("bucketfull") then
        if inst.waterlevel<3 and inst.beer==0 then
		    return true
	    else
		    return false
	    end
	end
	if item.prefab == ("cutwheat") then
        if inst.wheat<3 and inst.beer==0 and inst.waterlevel==3 then
		    return true
	    else
		    return false
	    end
	end
	if item.prefab == ("cup") then
        if inst.beer>0 then
		    return true
	    else
		    return false
	    end
	end
end

local function OnGetItemFromPlayer(inst, giver, item)
	if item.prefab == ("bucketfull") then
	    inst.waterlevel=inst.waterlevel+1
	    giver.components.inventory:GiveItem(SpawnPrefab("bucket"))
	end
	if item.prefab == ("cutwheat") then
	    inst.wheat=inst.wheat+1
	end
	if item.prefab == ("cup") then
	    inst.beer=inst.beer-1
		giver.components.inventory:GiveItem(SpawnPrefab("cup_beer"))
	end
end

local function OnSave(inst, data)
    data.waterlevel = inst.waterlevel
	data.wheat = inst.wheat
	data.beer = inst.beer
	data.wait = inst.wait
end

local function OnLoad(inst, data)
    if data ~= nil and data.waterlevel ~= nil then
        inst.waterlevel = data.waterlevel
    end
	if data ~= nil and data.wheat ~= nil then
        inst.wheat = data.wheat
    end
	if data ~= nil and data.beer ~= nil then
        inst.beer = data.beer
    end
	if data ~= nil and data.wait ~= nil then
        inst.wait = data.wait
    end
end

local function onopen(inst)
--	if inst.components.container:GetItemInSlot(1) ~= nil then
--	    print("Slot1 - "..inst.components.container:GetItemInSlot(1))
--	end
end

local function onbuilt(inst)
    inst.AnimState:PlayAnimation("beer_onbuild")
    inst.AnimState:PushAnimation("beer", false)
    inst.SoundEmitter:PlaySound("dontstarve/common/winter_meter_craft")
end

local function check_container(inst)
	if inst.components.container:GetItemInSlot(1) == "berries_juicy" then
		inst.components.container:Close()
		inst.components.container:DestroyContents()
		print("ITS WORK!")
		--print("Slot0 - "..inst.components.container:GetItemInSlot(0))
		--print("Slot1 - "..inst.components.container:GetItemInSlot(1))
	end
end

local function fn()
    local inst = CreateEntity()
    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    inst.entity:AddMiniMapEntity()
    --
	
	inst.beer = 0
    inst.waterlevel = 0
    inst.wheat = 0
    inst.wait = TUNING.BEER_WAIT

    MakeObstaclePhysics(inst, 0.66)

    inst:AddTag("structure")
	
	
	inst:AddTag("trader")
	
	inst:AddComponent("talker")
    inst.components.talker.fontsize = 24
	inst.components.talker.font = TALKINGFONT
	inst.components.talker.offset = Vector3(0,-390,0)
	inst.components.talker.colour = Vector3(130/255, 80/255, 160/255, 1)
	inst:DoPeriodicTask(1, checkstatusdon)
	inst:DoPeriodicTask(60, addbrew)

    inst.AnimState:SetBank("waterbarrle")
    inst.AnimState:SetBuild("waterbarrle")
    inst.AnimState:PlayAnimation("beer")
	inst.Transform:SetScale(0.68,0.68,0.68)

--
	
    inst:AddComponent("container")
    inst.components.container:WidgetSetup("cookpot")
	inst.components.container.onopenfn = onopen

    inst:AddComponent("inspectable")
	inst:ListenForEvent("onbuilt", onbuilt)
    inst:AddComponent("workable")
	inst:AddComponent("lootdropper")
	inst.components.workable:SetWorkAction(ACTIONS.HAMMER)
	inst.components.workable:SetWorkLeft(5)
	inst.components.workable:SetOnFinishCallback(onhammered)
	inst.components.workable:SetOnWorkCallback(onhit)
	inst:AddComponent("trader")
	inst.components.trader:SetAcceptTest(ShouldAcceptItem)
	inst.components.trader.onaccept = OnGetItemFromPlayer
	
    inst.OnSave = OnSave
    inst.OnLoad = OnLoad
	
	inst:DoPeriodicTask(1, check_container)

    return inst
end

return Prefab( "common/beer_barrle", fn, assets, prefabs),
        MakePlacer( "common/beer_barrle_placer", "waterbarrle", "waterbarrle", "beer" ) -- заканчиваем файл, возращением нашего префаба с использованием пред функции
