local assets =
{
	Asset("ANIM", "anim/items_ground.zip"),
	Asset("IMAGE", "images/inventoryimages/coffe_beans.tex"),
	Asset("ATLAS", "images/inventoryimages/coffe_beans.xml"),
	
	Asset("IMAGE", "images/inventoryimages/coffe_beans_raw.tex"),
	Asset("ATLAS", "images/inventoryimages/coffe_beans_raw.xml")
}

local function raw()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    --

    MakeInventoryPhysics(inst)	

    inst.AnimState:SetBuild("items_ground")
    inst.AnimState:SetBank("items_ground")
    inst.AnimState:PlayAnimation("coffe_raw")

    --

--
	
	--
	
	inst:AddComponent("edible")
	inst.components.edible.foodtype = "VEGGIE"
	inst.components.edible.healthvalue = 0
	inst.components.edible.hungervalue = 12.5
	inst.components.edible.sanityvalue = 0
	
	inst:AddTag("cookable")
	inst:AddComponent("cookable")
    inst.components.cookable.product = "coffe_beans"

    inst:AddComponent("inspectable")
	
    inst:AddTag("tradable")
	
	inst:AddComponent("stackable")
    inst.components.stackable.maxsize = TUNING.STACK_SIZE_SMALLITEM

    inst:AddComponent("inventoryitem")

   --:SetImage("coffe_beans_raw")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/coffe_beans_raw.xml"
	
	inst:AddComponent("perishable")
	inst.components.perishable:SetPerishTime(TUNING.PERISH_MED)
	inst.components.perishable:StartPerishing()
	inst.components.perishable.onperishreplacement = "spoiled_food"

    --

    return inst
end

local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    --

    MakeInventoryPhysics(inst)	

    inst.AnimState:SetBuild("items_ground")
    inst.AnimState:SetBank("items_ground")
    inst.AnimState:PlayAnimation("coffe")

    --

--
	
	--
	
	inst:AddComponent("edible")
	inst.components.edible.foodtype = "VEGGIE"
	inst.components.edible.healthvalue = -1
	inst.components.edible.hungervalue = 15
	inst.components.edible.sanityvalue = 2

    inst:AddComponent("inspectable")

	inst:AddComponent("stackable")
    inst.components.stackable.maxsize = TUNING.STACK_SIZE_SMALLITEM

    inst:AddComponent("inventoryitem")

   --:SetImage("coffe_beans")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/coffe_beans.xml"
	
	inst:AddTag("tradable")
	
	inst:AddComponent("perishable")
	inst.components.perishable:SetPerishTime(TUNING.PERISH_MED)
	inst.components.perishable:StartPerishing()
	inst.components.perishable.onperishreplacement = "spoiled_food"
	
    inst:AddComponent("tradable")

    --

    return inst
end

return Prefab("coffe_beans_raw", raw, assets),
Prefab("coffe_beans", fn, assets)
