--переписанно
local assets =
{
    Asset("ANIM", "anim/coffeebush.zip"),
    Asset("ANIM", "anim/grass.zip"),
    Asset("SOUND", "sound/common.fsb"),
    Asset("IMAGE", "images/water_images.tex"),
    Asset("ATLAS", "images/water_images.xml"),
}

local prefabs =
{
    "coffe_beans_raw",
    "dug_coffebush",
}

local function ontransplantfn(inst)
    inst.components.pickable:MakeEmpty()
end

local function dig_up(inst, chopper)
	if inst.components.pickable and inst.components.pickable:CanBePicked() then
		inst.components.lootdropper:SpawnLootPrefab("coffe_beans_raw")
	end
	inst:Remove()
	local bush = inst.components.lootdropper:SpawnLootPrefab("coffe_beans_raw")
end

local function onpickedfn(inst) 
	inst.AnimState:PlayAnimation("idle_picked")
    inst.AnimState:PushAnimation("idle")
end

local function onregenfn(inst)
	inst.AnimState:PlayAnimation("grow")
    inst.AnimState:PushAnimation("berriesmost", true)
end

local function makeemptyfn(inst)
    inst.AnimState:PushAnimation("idle")
end

local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddMiniMapEntity()
    --

    inst.MiniMapEntity:SetIcon("coffebush.tex")

    inst.AnimState:SetRayTestOnBB(true)
    inst.AnimState:SetBank("coffeebush")
    inst.AnimState:SetBuild("coffeebush")
    inst.AnimState:PlayAnimation("berriesmost", true)
	
	MakeObstaclePhysics(inst, 0.5)

    inst:AddTag("renewable")

    --

--

    inst.AnimState:SetTime(math.random() * 2)

    inst:AddComponent("pickable")
    inst.components.pickable.picksound = "dontstarve/wilson/pickup_reeds"

    inst.components.pickable:SetUp("coffe_beans_raw", TUNING.SAPLING_REGROW_TIME)
    inst.components.pickable.onregenfn = onregenfn
    inst.components.pickable.onpickedfn = onpickedfn
    inst.components.pickable.makeemptyfn = makeemptyfn
    inst.components.pickable.ontransplantfn = ontransplantfn

    inst:AddComponent("inspectable")
	
    inst:AddComponent("lootdropper")
    --inst:AddComponent("workable")
    --inst.components.workable:SetWorkAction(ACTIONS.DIG)
    --inst.components.workable:SetOnFinishCallback(dig_up)
    --inst.components.workable:SetWorkLeft(1)

    MakeMediumBurnable(inst)
    MakeSmallPropagator(inst)
    MakeNoGrowInWinter(inst)
    ---------------------   

    return inst
end

return Prefab("forest/objects/coffebush", fn, assets, prefabs)