local assets =
{
	Asset("ANIM", "anim/cups.zip"),
	Asset("IMAGE", "images/inventoryimages/cup_water.tex"),
	Asset("ATLAS", "images/inventoryimages/cup_water.xml"),
	Asset("IMAGE", "images/inventoryimages/cup.tex"),
	Asset("ATLAS", "images/inventoryimages/cup.xml"),
	Asset("IMAGE", "images/inventoryimages/cup_coffe.tex"),
	Asset("ATLAS", "images/inventoryimages/cup_coffe.xml"),
	Asset("IMAGE", "images/inventoryimages/cup_beer.tex"),
	Asset("ATLAS", "images/inventoryimages/cup_beer.xml"),
	Asset("IMAGE", "images/inventoryimages/cup_monster.tex"),
	Asset("ATLAS", "images/inventoryimages/cup_monster.xml"),
	Asset("IMAGE", "images/inventoryimages/cup_red.tex"),
	Asset("ATLAS", "images/inventoryimages/cup_red.xml"),
	Asset("IMAGE", "images/inventoryimages/cup_monster.tex"),
	Asset("ATLAS", "images/inventoryimages/cup_monster.xml"),
	Asset("IMAGE", "images/inventoryimages/cup_tee.tex"),
	Asset("ATLAS", "images/inventoryimages/cup_tee.xml"),
	Asset("IMAGE", "images/inventoryimages/cup_strang.tex"),
	Asset("ATLAS", "images/inventoryimages/cup_strang.xml"),
	
	Asset("SOUNDPACKAGE", "sound/fil_drink.fev"),	
    Asset("SOUND", "sound/fil_drink.fsb"),
}
--[[
local function setupedible(inst)
if not inst.components.edible then return end
inst.components.edible.healthvalue = TUNING.DRINKS_TABLE[inst.prefab]["health"]
inst.components.edible.hungervalue = TUNING.DRINKS_TABLE[inst.prefab]["hunger"]
inst.components.edible.sanityvalue = TUNING.DRINKS_TABLE[inst.prefab]["sanity"]
end
--]]

local function speeddown(eater)
	eater.components.talker:Say("I am again slow.")
  	eater.components.locomotor.externalspeedmultiplier = 1
	if eater.prefab ~= "wickerbottom" then
	    eater:RemoveTag("insomniac")
    end
end

local function oneatencoffe(inst, eater)
    if eater.components.thirst then 
	    eater.components.thirst:DoDelta(TUNING.DRINKCUP_COFFE) 
	end
	if eater:HasTag("player") then
	    eater:AddTag("insomniac")
	    eater.components.inventory:GiveItem(SpawnPrefab("cup"))
	    eater.components.talker:Say(TUNING.STAR_BAKS)
	    eater.components.locomotor.externalspeedmultiplier = TUNING.COFFEE_POWR
	    eater:DoTaskInTime(TUNING.COFFEE_TIME, speeddown)
    end
end

local function oneatengarbage(inst, eater)
    if eater:HasTag("player") then
	    eater.components.inventory:GiveItem(SpawnPrefab("cup"))
	end
end

local function oneatenhibiscus(inst, eater)
	if eater.components.thirst then 
        eater.components.thirst:DoDelta(TUNING.DRINKCUP_TEA)
	end
    if eater:HasTag("player") then
	    eater.components.inventory:GiveItem(SpawnPrefab("cup"))
	end
end

local function respawn(inst, eater)
	TheNet:Announce(""..ThePlayer:GetDisplayName().."'s ghost effect ended. Respawning!")
	eater:PushEvent("respawnfromghost")
end

local function oneatencup_abi(inst, eater)
    TheNet:Announce(""..ThePlayer:GetDisplayName().." drank Ghosty Drink, and became a ghost for 40 seconds!")
	eater:DoTaskInTime(40, function() respawn(inst, eater) end)
end

local function drinkdown(eater)
    if eater:HasTag("groggy") then
	    eater.components.talker:Say(TUNING.BEER_OFFDRINK)
	    eater:RemoveTag("groggy")
  	    eater.components.locomotor.externalspeedmultiplier = 1
	    eater:PushEvent("powerup")
	end
end

local function oneatenbeer(inst, eater)
    if eater.components.thirst then 
	    eater.components.thirst:DoDelta(TUNING.DRINKCUP_BEER) 
	end
    if eater:HasTag("player") then
	    eater.components.inventory:GiveItem(SpawnPrefab("cup"))
	end
end

local function oneatenmonster(inst, eater)
    if eater:HasTag("monster") and eater:HasTag("player") then
	    eater.components.inventory:GiveItem(SpawnPrefab("cup"))
		eater.components.health:DoDelta(37)
		eater.components.sanity:DoDelta(25)
		if eater.components.thirst then 
		    eater.components.thirst:DoDelta(TUNING.DRINKCUP_MONSTER) 
		end
    end
	if not eater:HasTag("monster") and eater:HasTag("player") then
	    eater.components.inventory:GiveItem(SpawnPrefab("cup"))
		eater.components.health:DoDelta(-10)
		eater.components.sanity:DoDelta(-20)
		eater.components.hunger:DoDelta(-10)
		if eater.components.thirst then 
		    eater.components.thirst:DoDelta(TUNING.DRINKCUP_MONSTER) 
		end
    end
end

local function baffout(eater)
    eater:RemoveTag("monster")
	eater.components.talker:Say("I feel like a human again!")
end

local function oneatencup_spider(inst, eater)
	if not eater:HasTag("monster") then
	    eater.components.inventory:GiveItem(SpawnPrefab("cup"))
	    eater:AddTag("monster")
	    eater.components.talker:Say("RGAHH!!I am monster!")
	    eater:DoTaskInTime(120, baffout)
		if eater.components.thirst then 
		    eater.components.thirst:DoDelta(TUNING.DRINKCUP_MONSTER) 
		end
	end
end

local function doareasleep(inst, range, time)
    local x, y, z = inst.Transform:GetWorldPosition()
    local ents = TheSim:FindEntities(x, y, z, range)
    for i, v in ipairs(ents) do
        if not (v.components.freezable ~= nil and v.components.freezable:IsFrozen()) and
            not (v.components.pinnable ~= nil and v.components.pinnable:IsStuck()) then
            if v:HasTag("player") then
                v:PushEvent("yawn", { grogginess = 4, knockoutduration = time + math.random() })
            elseif v.components.sleeper ~= nil then
                v.components.sleeper:AddSleepiness(7, time + math.random())
            elseif v.components.grogginess ~= nil then
                v.components.grogginess:AddGrogginess(4, time + math.random())
            else
                v:PushEvent("knockedout")
            end
        end
    end
end

local function oneatenred(inst, eater)
    if eater:HasTag("player") then
	    eater.components.inventory:GiveItem(SpawnPrefab("cup"))
	end
	if eater.components.thirst then 
	    eater.components.thirst:DoDelta(TUNING.DRINKCUP_DRAGON) 
	end
end

local function oneatencup_strang(inst, eater)
    if eater:HasTag("player") then
	    eater.components.inventory:GiveItem(SpawnPrefab("cup"))
	    eater.components.talker:Say(TUNING.POHMEL)
	end
	if eater.components.thirst then 
	    eater.components.thirst:DoDelta(15) 
	end
end

local function oneatentea(inst, eater)
	if eater.components.thirst then 
        eater.components.thirst:DoDelta(TUNING.DRINKCUP_TEA)
	end
    if eater:HasTag("player") then
	    eater.components.inventory:GiveItem(SpawnPrefab("cup"))
	    eater.components.talker:Say(TUNING.TEA_YAWN)
	end
end

local function oneatencup_water(inst, eater)
    if eater:HasTag("player") then
	    eater.components.inventory:GiveItem(SpawnPrefab("cup"))
		--eater.SoundEmitter:PlaySound("fil_drink/drinks/normal")
	end
	if eater.components.thirst then
	    eater.components.thirst:DoDelta(TUNING.DRINKCUP_WATER) 
	end
end

local function cup_water()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    --

    MakeInventoryPhysics(inst)
	
	inst:AddTag("drink")

    inst.AnimState:SetBuild("cups")
    inst.AnimState:SetBank("cups")
    inst.AnimState:PlayAnimation("water")

    --

--
	
	inst:AddComponent("stackable")
    inst.components.stackable.maxsize = TUNING.STACK_SIZE_SMALLITEM

    inst:AddComponent("inspectable")
	
	inst:AddComponent("edible")
	--
    inst.components.edible.healthvalue = 5
    inst.components.edible.hungervalue = 5
    inst.components.edible.sanityvalue = 0
	inst.components.edible:SetOnEatenFn(oneatencup_water)

    inst:AddTag("show_spoilage")

    inst:AddComponent("inventoryitem")

   --:SetImage("cup_water")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/cup_water.xml"

    --

    return inst
end

local function cup_tea()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    --

    MakeInventoryPhysics(inst)	

    inst.AnimState:SetBuild("cups")
    inst.AnimState:SetBank("cups")
    inst.AnimState:PlayAnimation("idle")

    --

--

    inst:AddComponent("inspectable")
	
	inst:AddComponent("stackable")
    inst.components.stackable.maxsize = TUNING.STACK_SIZE_SMALLITEM
	
	inst:AddComponent("edible")
	--
    inst.components.edible.healthvalue = 7
    inst.components.edible.hungervalue = 5
    inst.components.edible.sanityvalue = 20
	inst.components.edible:SetOnEatenFn(oneatentea)
	
    inst:AddTag("show_spoilage")

    inst:AddComponent("inventoryitem")

   --:SetImage("cup_tee")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/cup_tee.xml"

    --

    return inst
end

local function cup_strang()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    --

    MakeInventoryPhysics(inst)	

    inst.AnimState:SetBuild("cups")
    inst.AnimState:SetBank("cups")
    inst.AnimState:PlayAnimation("coffe")

    --

--

    inst:AddComponent("inspectable")
	
	inst:AddComponent("stackable")
    inst.components.stackable.maxsize = TUNING.STACK_SIZE_SMALLITEM
	
	inst:AddComponent("edible")
	--
    inst.components.edible.healthvalue = -2
    inst.components.edible.hungervalue = -3
    inst.components.edible.sanityvalue = -5
	inst.components.edible:SetOnEatenFn(oneatencup_strang)

    inst:AddTag("show_spoilage")

    inst:AddComponent("inventoryitem")

   --:SetImage("cup_strang")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/cup_strang.xml"

    --

    return inst
end

local function cup_red()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    --

    MakeInventoryPhysics(inst)	

    inst.AnimState:SetBuild("cups")
    inst.AnimState:SetBank("cups")
    inst.AnimState:PlayAnimation("red")

    --

--

    inst:AddComponent("inspectable")
	
	inst:AddComponent("stackable")
    inst.components.stackable.maxsize = TUNING.STACK_SIZE_SMALLITEM
	
	inst:AddComponent("edible")
	--
    inst.components.edible.healthvalue = 45
    inst.components.edible.hungervalue = 10
    inst.components.edible.sanityvalue = 55
	inst.components.edible:SetOnEatenFn(oneatenred)
	
    inst:AddTag("show_spoilage")

    inst:AddComponent("inventoryitem")

   --:SetImage("cup_red")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/cup_red.xml"

    --

    return inst
end

local function cup_hibiscus()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    --

    MakeInventoryPhysics(inst)	

    inst.AnimState:SetBuild("cups")
    inst.AnimState:SetBank("cups")
    inst.AnimState:PlayAnimation("red")

    --

--

    inst:AddComponent("inspectable")
	
	inst:AddComponent("stackable")
    inst.components.stackable.maxsize = TUNING.STACK_SIZE_SMALLITEM
	
	inst:AddComponent("edible")
	--
    inst.components.edible.healthvalue = 15
    inst.components.edible.hungervalue = 10
    inst.components.edible.sanityvalue = 22
	inst.components.edible:SetOnEatenFn(oneatenhibiscus)
	
    inst:AddTag("show_spoilage")

    inst:AddComponent("inventoryitem")

   --:SetImage("cup_red")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/cup_red.xml"

    --

    return inst
end

local function cup_spider()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    --

    MakeInventoryPhysics(inst)	

    inst.AnimState:SetBuild("cups")
    inst.AnimState:SetBank("cups")
    inst.AnimState:PlayAnimation("coffe")

    --

--

    inst:AddComponent("inspectable")
	
	inst:AddComponent("stackable")
    inst.components.stackable.maxsize = TUNING.STACK_SIZE_SMALLITEM
	
	inst:AddComponent("edible")
	--
    inst.components.edible.healthvalue = 0
    inst.components.edible.hungervalue = 15
    inst.components.edible.sanityvalue = -5
	inst.components.edible:SetOnEatenFn(oneatencup_spider)
	
    inst:AddTag("show_spoilage")

    inst:AddComponent("inventoryitem")
	
	inst:AddComponent("selfstacker")

   --:SetImage("cup_monster")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/cup_monster.xml"

    --

    return inst
end

local function cup_monster()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    --

    MakeInventoryPhysics(inst)	

    inst.AnimState:SetBuild("cups")
    inst.AnimState:SetBank("cups")
    inst.AnimState:PlayAnimation("coffe")

    --

--

    inst:AddComponent("inspectable")
	
	inst:AddComponent("stackable")
    inst.components.stackable.maxsize = TUNING.STACK_SIZE_SMALLITEM
	
	inst:AddComponent("edible")
	--
    inst.components.edible.healthvalue = 0
    inst.components.edible.hungervalue = 0
    inst.components.edible.sanityvalue = 0
	inst.components.edible:SetOnEatenFn(oneatenmonster)
	
    inst:AddTag("show_spoilage")

    inst:AddComponent("inventoryitem")
	
	inst:AddComponent("selfstacker")

   --:SetImage("cup_monster")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/cup_monster.xml"

    --

    return inst
end

local function cup_coffe()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    --

    MakeInventoryPhysics(inst)	

    inst.AnimState:SetBuild("cups")
    inst.AnimState:SetBank("cups")
    inst.AnimState:PlayAnimation("coffe")

    --

--

    inst:AddComponent("inspectable")
	
	inst:AddComponent("stackable")
    inst.components.stackable.maxsize = TUNING.STACK_SIZE_SMALLITEM
	
	inst:AddComponent("edible")
	--
    inst.components.edible.healthvalue = 5
    inst.components.edible.hungervalue = 5
    inst.components.edible.sanityvalue = 19
	inst.components.edible:SetOnEatenFn(oneatencoffe)

    inst:AddTag("show_spoilage")

    inst:AddComponent("inventoryitem")

   --:SetImage("cup_coffe")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/cup_coffe.xml"

    --

    return inst
end

local function cup_garbage()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    --

    MakeInventoryPhysics(inst)	

    inst.AnimState:SetBuild("cups")
    inst.AnimState:SetBank("cups")
    inst.AnimState:PlayAnimation("beer")

    --

--

    inst:AddComponent("inspectable")
	
	inst:AddComponent("stackable")
    inst.components.stackable.maxsize = TUNING.STACK_SIZE_SMALLITEM
	
	inst:AddComponent("edible")
	--
    inst.components.edible.healthvalue = -5
    inst.components.edible.hungervalue = -7
    inst.components.edible.sanityvalue = -10
	inst.components.edible:SetOnEatenFn(oneatengarbage)

    inst:AddTag("show_spoilage")

    inst:AddComponent("inventoryitem")

   --:SetImage("cup_beer")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/cup_beer.xml"

    --

    return inst
end

local function cup_beer()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    --

    MakeInventoryPhysics(inst)	

    inst.AnimState:SetBuild("cups")
    inst.AnimState:SetBank("cups")
    inst.AnimState:PlayAnimation("beer")

    --

--

    inst:AddComponent("inspectable")
	
	inst:AddComponent("stackable")
    inst.components.stackable.maxsize = TUNING.STACK_SIZE_SMALLITEM
	
	inst:AddComponent("edible")
	--
    inst.components.edible.healthvalue = -10
    inst.components.edible.hungervalue = 10
    inst.components.edible.sanityvalue = 55
	inst.components.edible:SetOnEatenFn(oneatenbeer)

    inst:AddTag("show_spoilage")

    inst:AddComponent("inventoryitem")

   --:SetImage("cup_beer")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/cup_beer.xml"

    --

    return inst
end

local function cup_abi()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    --

    MakeInventoryPhysics(inst)	

    inst.AnimState:SetBuild("cups")
    inst.AnimState:SetBank("cups")
    inst.AnimState:PlayAnimation("red")

    --

--

    inst:AddComponent("inspectable")
	
	inst:AddComponent("stackable")
    inst.components.stackable.maxsize = TUNING.STACK_SIZE_SMALLITEM
	
	inst:AddComponent("edible")
	--
    inst.components.edible.healthvalue = -1000
    inst.components.edible.hungervalue = 5
    inst.components.edible.sanityvalue = 19
	inst.components.edible:SetOnEatenFn(oneatencup_abi)

    inst:AddTag("show_spoilage")

    inst:AddComponent("inventoryitem")

   --:SetImage("cup_red")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/cup_red.xml"

    --

    return inst
end

local function cup()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    --

    MakeInventoryPhysics(inst)	

    inst.AnimState:SetBuild("cups")
    inst.AnimState:SetBank("cups")
    inst.AnimState:PlayAnimation("idle")

    --

--

    inst:AddComponent("inspectable")

	inst:AddComponent("tradable")

    inst:AddTag("show_spoilage")
	
	inst:AddComponent("tradable")
	
	inst:AddComponent("stackable")
    inst.components.stackable.maxsize = TUNING.STACK_SIZE_SMALLITEM

    inst:AddComponent("inventoryitem")

   --:SetImage("cup_empety")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/cup.xml"

    return inst
end

return Prefab("cup", cup, assets),
--Prefab("cup_abi", cup_abi, assets),
Prefab("cup_beer", cup_beer, assets),
Prefab("cup_coffe", cup_coffe, assets),
Prefab("cup_monster", cup_monster, assets),
Prefab("cup_spider", cup_spider, assets),
Prefab("cup_red", cup_red, assets),
Prefab("cup_strang", cup_strang, assets),
Prefab("cup_tee", cup_tea, assets),
Prefab("cup_water", cup_water, assets),
Prefab("cup_garbage", cup_garbage, assets),
Prefab("cup_hibiscus", cup_hibiscus, assets)