
local assets =
{
	Asset("ANIM", "anim/coffeebush.zip"),
	
	Asset("ATLAS", "images/inventoryimages/dig_coffebush.xml"),
	
	Asset("IMAGE", "images/inventoryimages/dig_coffebush.tex"),
}

local function ground(inst, pt)
	local tiletype = TheWorld.Map:GetTileAtPoint(pt:Get())
	local ground_OK = tiletype == GROUND.MARSH
	
	if ground_OK then
    	return true
	end

	return false
	
end

local function CanDeploy(inst) return true end

local function ondeploy(inst, pt)
	local coffebush = SpawnPrefab("coffebush") 
	if coffebush then 
		coffebush.Transform:SetPosition(pt.x, pt.y, pt.z) 
		inst.components.stackable:Get():Remove()
		coffebush.components.pickable:OnTransplant()
	end 
end

local function fn(Sim)
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	MakeInventoryPhysics(inst)
	--
   
	inst.AnimState:SetBank("coffeebush")
	inst.AnimState:SetBuild("coffeebush")
	inst.AnimState:PlayAnimation("dug")

	inst:AddTag("renewable")


	if not TheWorld.ismastersim then
	    return inst
    end
	
	inst:AddComponent("stackable")
	inst.components.stackable.maxsize = TUNING.STACK_SIZE_LARGEITEM
	
	inst:AddComponent("inspectable")

	inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/inventoryimages/dig_coffebush.xml"
    inst.components.inventoryitem.imagename = "dig_coffebush"
	
	inst:AddComponent("fuel")
	inst.components.fuel.fuelvalue = TUNING.LARGE_FUEL
    

    MakeMediumBurnable(inst, TUNING.LARGE_BURNTIME)
	MakeSmallPropagator(inst)  
	
    inst:AddComponent("deployable")
    inst.components.deployable.ondeploy = ondeploy
    inst.components.deployable.test = ground
	--inst.components.deployable:SetDeployMode(DEPLOYMODE.PLANT)
    --inst.components.deployable:SetDeploySpacing(DEPLOYSPACING.MEDIUM)
	---------------------  
	return inst      
end

return Prefab( "common/objects/dug_coffebush", fn, assets),
	MakePlacer( "common/dug_coffebush_placer", "coffeebush", "coffeebush", "berriesmost")
