local assets=
{
	Asset("ANIM", "anim/tee_tree.zip"),
	Asset("IMAGE", "images/water_images.tex"),
	Asset("ATLAS", "images/water_images.xml"),
}

local function CanDeploy(inst) return true end

local function ondeploy(inst, pt)
	local tree = SpawnPrefab("tee_tree") 
	if tree then 
		tree.Transform:SetPosition(pt.x, pt.y, pt.z) 
		inst.components.stackable:Get():Remove()
		tree.components.pickable:OnTransplant()
		tree.SoundEmitter:PlaySound("dontstarve/wilson/plant_tree")
	end 
end

local function fn(Sim)
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	MakeInventoryPhysics(inst)

	inst.AnimState:SetBank("tee_tree")
	inst.AnimState:SetBuild("tee_tree")
	inst.AnimState:PlayAnimation("dropped")


	inst:AddComponent("pickable")
	inst:AddComponent("stackable")
	inst.components.stackable.maxsize = TUNING.STACK_SIZE_LARGEITEM
	
	inst:AddComponent("inspectable")
	inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.imagename = "dig_tee_tree"	
    inst.components.inventoryitem.atlasname = "images/water_images.xml"
		   
	inst:AddComponent("fuel")
	inst.components.fuel.fuelvalue = TUNING.LARGE_FUEL
    

    MakeMediumBurnable(inst)
    MakeSmallPropagator(inst)
	
    inst:AddComponent("deployable")
    inst.components.deployable.ondeploy = ondeploy
    --inst.components.deployable.test = test_ground
    inst.components.deployable.min_spacing = 2
    
	---------------------  
	return inst      
end

	return Prefab( "common/dug_tee_tree", fn, assets),
		MakePlacer( "common/dug_tee_tree", "tee_tree", "tee_tree", "idle")
