local assets =
{
	Asset("ANIM", "anim/items_ground.zip"),
	
	Asset("IMAGE", "images/water_images.tex"),
	Asset("ATLAS", "images/water_images.xml")
}

local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()

    MakeInventoryPhysics(inst)	

    inst.AnimState:SetBuild("items_ground")
    inst.AnimState:SetBank("items_ground")
    inst.AnimState:PlayAnimation("bag_idle")
	
    inst:AddComponent("useableitem")
    inst.components.useableitem.verb = "OPEN"
    inst.components.useableitem:SetCanInteractFn(function() return true end)
    inst.components.useableitem:SetOnUseFn(function(inst)
        GetPlayer().components.inventory:GiveItem(steak)
	    GetPlayer().components.inventory:GiveItem(SpawnPrefab("dug_tee_tree"))
	    GetPlayer().components.inventory:GiveItem(SpawnPrefab("dug_tee_tree"))
	    GetPlayer().components.inventory:GiveItem(SpawnPrefab("dug_coffebush"))
	    GetPlayer().components.inventory:GiveItem(SpawnPrefab("dug_coffebush"))
	    GetPlayer().components.inventory:GiveItem(SpawnPrefab("dug_wheat"))
	    GetPlayer().components.inventory:GiveItem(SpawnPrefab("dug_wheat"))

        inst:Remove()
    end)
	
    inst:AddComponent("inspectable")

    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.imagename = "dig_tee_tree"	
    inst.components.inventoryitem.atlasname = "images/water_images.xml"

    return inst
end

return Prefab("grass_bag", fn, assets)