local assets =
{
	Asset("ANIM", "anim/cups.zip"),
	Asset("IMAGE", "images/inventoryimages/soda1.tex"),
	Asset("ATLAS", "images/inventoryimages/soda1.xml"),
	Asset("IMAGE", "images/inventoryimages/soda2.tex"),
	Asset("ATLAS", "images/inventoryimages/soda2.xml"),
	Asset("IMAGE", "images/inventoryimages/soda3.tex"),
	Asset("ATLAS", "images/inventoryimages/soda3.xml"),
	Asset("IMAGE", "images/inventoryimages/soda4.tex"),
	Asset("ATLAS", "images/inventoryimages/soda4.xml"),
}

local function ondrinksoda(inst, eater)
	if eater.components.thirst then
	    eater.components.thirst:DoDelta(TUNING.DRINK_SODA) 
	end
end

local function soda1()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    --

    MakeInventoryPhysics(inst)	
	

    inst.AnimState:SetBuild("cups")
    inst.AnimState:SetBank("cups")
    inst.AnimState:PlayAnimation("soda1")

    --

--

    inst:AddComponent("inspectable")
	
	inst:AddComponent("stackable")
    inst.components.stackable.maxsize = TUNING.STACK_SIZE_SMALLITEM
	
	inst:AddComponent("edible")
	inst.components.edible.foodtype = FOODTYPE.GOODIES
    inst.components.edible.healthvalue = 10
    inst.components.edible.hungervalue = 10
    inst.components.edible.sanityvalue = 40
	inst.components.edible:SetOnEatenFn(ondrinksoda)
	
    inst:AddTag("show_spoilage")

    inst:AddComponent("inventoryitem")

   --:SetImage("soda1")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/soda1.xml"

    --

    return inst
end

local function soda2()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    --

    MakeInventoryPhysics(inst)	
	

    inst.AnimState:SetBuild("cups")
    inst.AnimState:SetBank("cups")
    inst.AnimState:PlayAnimation("soda2")

    --

--

    inst:AddComponent("inspectable")
	
	inst:AddComponent("stackable")
    inst.components.stackable.maxsize = TUNING.STACK_SIZE_SMALLITEM
	
	inst:AddComponent("edible")
	inst.components.edible.foodtype = FOODTYPE.GOODIES
    inst.components.edible.healthvalue = 10
    inst.components.edible.hungervalue = 10
    inst.components.edible.sanityvalue = 40
	inst.components.edible:SetOnEatenFn(ondrinksoda)
	
    inst:AddTag("show_spoilage")

    inst:AddComponent("inventoryitem")

   --:SetImage("soda2")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/soda2.xml"

    --

    return inst
end

local function soda3()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    --

    MakeInventoryPhysics(inst)	
	

    inst.AnimState:SetBuild("cups")
    inst.AnimState:SetBank("cups")
    inst.AnimState:PlayAnimation("soda3")

    --

--

    inst:AddComponent("inspectable")
	
	inst:AddComponent("stackable")
    inst.components.stackable.maxsize = TUNING.STACK_SIZE_SMALLITEM
	
	inst:AddComponent("edible")
	inst.components.edible.foodtype = FOODTYPE.GOODIES
    inst.components.edible.healthvalue = 10
    inst.components.edible.hungervalue = 10
    inst.components.edible.sanityvalue = 40
	inst.components.edible:SetOnEatenFn(ondrinksoda)
	
    inst:AddTag("show_spoilage")

    inst:AddComponent("inventoryitem")

   --:SetImage("soda3")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/soda3.xml"

    --

    return inst
end

local function soda4()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    --

    MakeInventoryPhysics(inst)	
	

    inst.AnimState:SetBuild("cups")
    inst.AnimState:SetBank("cups")
    inst.AnimState:PlayAnimation("soda4")

    --

--

    inst:AddComponent("inspectable")
	
	inst:AddComponent("stackable")
    inst.components.stackable.maxsize = TUNING.STACK_SIZE_SMALLITEM
	
	inst:AddComponent("edible")
	inst.components.edible.foodtype = FOODTYPE.GOODIES
    inst.components.edible.healthvalue = 10
    inst.components.edible.hungervalue = 10
    inst.components.edible.sanityvalue = 40
	inst.components.edible:SetOnEatenFn(ondrinksoda)
	
    inst:AddTag("show_spoilage")

    inst:AddComponent("inventoryitem")

   --:SetImage("soda4")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/soda4.xml"

    --

    return inst
end

return Prefab("soda1", soda1, assets),
Prefab("soda2", soda2, assets),
Prefab("soda3", soda3, assets),
Prefab("soda4", soda4, assets)
