local assets =
{
	Asset("ANIM", "anim/tee.zip"),
	Asset("IMAGE", "images/water_images.tex"),
    Asset("ATLAS", "images/water_images.xml"),
    Asset("ATLAS", "images/inventoryimages/tee.xml"),
	Asset("ATLAS", "images/inventoryimages/tee_s.xml"),
	Asset("ATLAS", "images/inventoryimages/tee_m.xml"),
	Asset("IMAGE", "images/inventoryimages/tee_r.tex"),
	Asset("ATLAS", "images/inventoryimages/tee_r.xml"),
	Asset("IMAGE", "images/inventoryimages/tee_r2.tex"),
	Asset("ATLAS", "images/inventoryimages/tee_r2.xml")
}


local function tea_common()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    --

    MakeInventoryPhysics(inst)	

    inst.AnimState:SetBuild("tee")
    inst.AnimState:SetBank("tee")
    inst.AnimState:PlayAnimation("idle")

    --

--
	
	inst:AddComponent("stackable")
    inst.components.stackable.maxsize = TUNING.STACK_SIZE_SMALLITEM

    inst:AddComponent("inspectable")

    inst:AddComponent("inventoryitem")

   --:SetImage("tee")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/tee.xml"

    --

    return inst
end

local function tea_g()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    --

    MakeInventoryPhysics(inst)	

    inst.AnimState:SetBuild("tee")
    inst.AnimState:SetBank("tee")
    inst.AnimState:PlayAnimation("ghost")

    --

--

    inst:AddComponent("inspectable")
	
	inst:AddComponent("tradable")
	
	inst:AddComponent("stackable")
    inst.components.stackable.maxsize = TUNING.STACK_SIZE_SMALLITEM

    inst:AddTag("show_spoilage")
	

    inst:AddComponent("inventoryitem")

   --:SetImage("tee_g")
    inst.components.inventoryitem.atlasname = "images/water_images.xml"

    --

    return inst
end

local function tea_m()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    --

    MakeInventoryPhysics(inst)	

    inst.AnimState:SetBuild("tee")
    inst.AnimState:SetBank("tee")
    inst.AnimState:PlayAnimation("s_m")

    --

--

    inst:AddComponent("inspectable")
	
	inst:AddComponent("tradable")
	
	inst:AddComponent("stackable")
    inst.components.stackable.maxsize = TUNING.STACK_SIZE_SMALLITEM

    inst:AddTag("show_spoilage")
	
	inst:AddTag("bundle")

    inst:AddComponent("inventoryitem")

   --:SetImage("tee_m")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/tee_m.xml"

    --

    return inst
end

local function tea_s()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    --

    MakeInventoryPhysics(inst)	

    inst.AnimState:SetBuild("tee")
    inst.AnimState:SetBank("tee")
    inst.AnimState:PlayAnimation("s")

    --

--

    inst:AddComponent("inspectable")
	
	inst:AddComponent("tradable")
	
	inst:AddComponent("stackable")
    inst.components.stackable.maxsize = TUNING.STACK_SIZE_SMALLITEM

    inst:AddTag("show_spoilage")
	

    inst:AddComponent("inventoryitem")

   --:SetImage("tee__s")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/tee_s.xml"

    --

    return inst
end

local function tea_r()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    --

    MakeInventoryPhysics(inst)	

    inst.AnimState:SetBuild("tee")
    inst.AnimState:SetBank("tee")
    inst.AnimState:PlayAnimation("red")

    --

--

    inst:AddComponent("inspectable")
	
	inst:AddComponent("tradable")
	
	inst:AddComponent("stackable")
    inst.components.stackable.maxsize = TUNING.STACK_SIZE_SMALLITEM

    inst:AddTag("show_spoilage")
	

    inst:AddComponent("inventoryitem")

   --:SetImage("tee_r")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/tee_r.xml"

    --

    return inst
end

local function tea_r2()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    --

    MakeInventoryPhysics(inst)	

    inst.AnimState:SetBuild("tee")
    inst.AnimState:SetBank("tee")
    inst.AnimState:PlayAnimation("red2")

    --

--

    inst:AddComponent("inspectable")
	
	inst:AddComponent("tradable")
	
	inst:AddComponent("stackable")
    inst.components.stackable.maxsize = TUNING.STACK_SIZE_SMALLITEM

    inst:AddTag("show_spoilage")
	

    inst:AddComponent("inventoryitem")

   --:SetImage("tee_r")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/tee_r2.xml"

    --

    return inst
end

return Prefab("tee", tea_common, assets),
	   Prefab("tee_g", tea_g, assets),
	   Prefab("tee_m", tea_m, assets),
	   Prefab("tee_s", tea_s, assets),
	   Prefab("tee_r", tea_r, assets),
	   Prefab("tee_r2", tea_r2, assets)
