local assets =
{
    Asset("ANIM", "anim/tee_tree.zip"),
    Asset("ANIM", "anim/tee_tree_diseased_build.zip"),
    Asset("SOUND", "sound/common.fsb"),
}

local prefabs =
{
    "twigs",
    "dug_sapling",
    "disease_puff",
    "diseaseflies",
    "spoiled_food",
}

local function ontransplantfn(inst)
	inst.components.pickable:MakeEmpty()
end

local function dig_up(inst, chopper)
	if inst.components.pickable and inst.components.pickable:CanBePicked() then
		inst.components.lootdropper:SpawnLootPrefab("tee")
	end
	inst:Remove()
	local bush = inst.components.lootdropper:SpawnLootPrefab("dug_tee_tree")
end

local function onpickedfn(inst)
    inst.AnimState:PlayAnimation("picked")
    inst.AnimState:PushAnimation("idle_empty", true)
end

local function onregenfn(inst)
	inst.AnimState:PlayAnimation("grow")
    inst.AnimState:PushAnimation("idle", true)
end

local function makeemptyfn(inst)
	inst.AnimState:PlayAnimation("idle_empty", true)
end

local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddMiniMapEntity()
    --

    inst.AnimState:SetRayTestOnBB(true)
    inst.AnimState:SetBank("tee_tree")
    inst.AnimState:SetBuild("tee_tree")
    inst.AnimState:PlayAnimation("idle", true)
	
	MakeObstaclePhysics(inst, 0.5)

    inst:AddTag("renewable")

    --witherable (from witherable component) added to pristine state for optimization
    inst:AddTag("witherable")

    --

--

    inst.AnimState:SetTime(math.random() * 2)

    inst:AddComponent("pickable")
    inst.components.pickable.picksound = "dontstarve/wilson/harvest_berries"

    inst.components.pickable:SetUp("tee", TUNING.SAPLING_REGROW_TIME)
    inst.components.pickable.onregenfn = onregenfn
    inst.components.pickable.onpickedfn = onpickedfn
    inst.components.pickable.makeemptyfn = makeemptyfn
    inst.components.pickable.ontransplantfn = ontransplantfn

    inst:AddComponent("inspectable")

    inst:AddComponent("lootdropper")
    --inst:AddComponent("workable")
    --inst.components.workable:SetWorkAction(ACTIONS.DIG)
    --inst.components.workable:SetOnFinishCallback(dig_up)
    --inst.components.workable:SetWorkLeft(1)

    MakeMediumBurnable(inst)
    MakeSmallPropagator(inst)
    MakeNoGrowInWinter(inst)

    return inst
end

return Prefab("tee_tree", fn, assets, prefabs)
