--переписанно
local assets =
{
    Asset("ANIM", "anim/wheat.zip"),
    Asset("ANIM", "anim/grass.zip"),
    Asset("SOUND", "sound/common.fsb"),
    Asset("IMAGE", "images/water_images.tex"),
    Asset("ATLAS", "images/water_images.xml"),
}

local prefabs =
{
    "cutwheat",
    "dug_wheat",
}

local function ontransplantfn(inst)
    inst.components.pickable:MakeEmpty()
end

local function dig_up(inst, chopper)
	if inst.components.pickable and inst.components.pickable:CanBePicked() then
		inst.components.lootdropper:SpawnLootPrefab("cutwheat")
	end
	inst:Remove()
	local bush = inst.components.lootdropper:SpawnLootPrefab("dug_wheat")
end

local function onpickedfn(inst)
    inst.AnimState:PlayAnimation("picking") 
    inst.AnimState:PushAnimation("picked")
end

local function onregenfn(inst)
    inst.AnimState:PlayAnimation("grow") 
    inst.AnimState:PushAnimation("idle", true)
end

local function makeemptyfn(inst)
    inst.AnimState:PlayAnimation("picking")
    inst.AnimState:PushAnimation("picked")
end

local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddMiniMapEntity()
    --

    inst.MiniMapEntity:SetIcon("wheat.tex")

    inst.AnimState:SetRayTestOnBB(true)
    inst.AnimState:SetBank("grass")
    inst.AnimState:SetBuild("wheat")
    inst.AnimState:PlayAnimation("idle", true)

    inst:AddTag("renewable")

    --

--

    inst.AnimState:SetTime(math.random() * 2)

    inst:AddComponent("pickable")
    inst.components.pickable.picksound = "dontstarve/wilson/pickup_reeds"

    inst.components.pickable:SetUp("cutwheat", TUNING.SAPLING_REGROW_TIME)
    inst.components.pickable.onregenfn = onregenfn
    inst.components.pickable.onpickedfn = onpickedfn
    inst.components.pickable.makeemptyfn = makeemptyfn
    inst.components.pickable.ontransplantfn = ontransplantfn

    inst:AddComponent("inspectable")

    --inst:AddComponent("lootdropper")
    --inst:AddComponent("workable")
    --inst.components.workable:SetWorkAction(ACTIONS.DIG)
    --inst.components.workable:SetOnFinishCallback(dig_up)
    --inst.components.workable:SetWorkLeft(1)

    MakeMediumBurnable(inst)
    MakeSmallPropagator(inst)
    MakeNoGrowInWinter(inst)    
    ---------------------   

    return inst
end

return Prefab("forest/objects/wheat", fn, assets, prefabs)