local _G = GLOBAL
local RECIPETABS = _G.RECIPETABS
local TECH = _G.TECH
local Ingredient = _G.Ingredient
--Config
local craft_bag=GetModConfigData("craft_bag")

local DST = GLOBAL.TheSim and GLOBAL.TheSim:GetGameID()=="DST"
local ROG = DST or GLOBAL.IsDLCEnabled(GLOBAL.REIGN_OF_GIANTS)

local MakeRecipe = DST and AddRecipe or function(name,ingr,tab,tech,placer,spacing,nounlock,num,_,atlas,image)
local rec = GLOBAL.Recipe(name,ingr,tab,tech,placer,spacing,nounlock,num,_)
rec.atlas = atlas
rec.image = image
end

MakeRecipe("cup", 
{Ingredient("flint", 3)} ,
RECIPETABS.DRINKS_TAB, 
TECH.NONE, 
nil, 
nil, 
nil, 
nil, 
nil, 
"images/inventoryimages/cup.xml", 
"cup.tex")

MakeRecipe( "bucket",
{Ingredient("log", 4)} ,
RECIPETABS.DRINKS_TAB, 
TECH.NONE,
nil,
nil,
nil,
nil,
nil,
"images/inventoryimages/bucket.xml",
"bucket.tex")

local RECIPE_GAME_TYPE = GLOBAL.RECIPE_GAME_TYPE

if _G.IsDLCEnabled(_G.CAPY_DLC) then
	
	local waterbarrle = Recipe("waterbarrle",{ Ingredient("boards", 2), Ingredient("rope", 2)}, RECIPETABS.DRINKS_TAB, TECH.SCIENCE_ONE, RECIPE_GAME_TYPE.COMMON, "waterbarrle_placer", 1.6)
	waterbarrle.atlas = "images/inventoryimages/waterbarrle.xml", "waterbarrle.tex"
	
	local beer_barrle = Recipe("beer_barrle",{ Ingredient("boards", 2), Ingredient("rope", 2)}, RECIPETABS.DRINKS_TAB, TECH.SCIENCE_TWO, RECIPE_GAME_TYPE.COMMON, "beer_barrle_placer", 1.6)
	beer_barrle.atlas = "images/inventoryimages/beer_barrle.xml", "beer_barrle.tex"
	
	local kettle = Recipe("kettle",{ Ingredient("twigs", 6), Ingredient("rope", 2), Ingredient("charcoal", 2)}, RECIPETABS.DRINKS_TAB, TECH.SCIENCE_ONE, RECIPE_GAME_TYPE.COMMON, "kettle_placer", 1.6)
	kettle.atlas = "images/water_images.xml", "kettle.tex"
else	
	local waterbarrle = Recipe("waterbarrle",{ Ingredient("boards", 2), Ingredient("rope", 2)}, RECIPETABS.DRINKS_TAB, TECH.SCIENCE_ONE, "waterbarrle_placer", 1.6)
	waterbarrle.atlas = "images/inventoryimages/waterbarrle.xml", "waterbarrle.tex"
	
	local beer_barrle = Recipe("beer_barrle",{ Ingredient("boards", 2), Ingredient("rope", 2)}, RECIPETABS.DRINKS_TAB, TECH.SCIENCE_TWO, "beer_barrle_placer", 1.6)
	beer_barrle.atlas = "images/inventoryimages/beer_barrle.xml", "beer_barrle.tex"

	local kettle = Recipe("kettle",{ Ingredient("twigs", 6), Ingredient("rope", 2), Ingredient("charcoal", 2)}, RECIPETABS.DRINKS_TAB, TECH.SCIENCE_ONE, "kettle_placer", 1.6)
	kettle.atlas = "images/water_images.xml", "kettle.tex"
end

MakeRecipe( "kettle_port",
{Ingredient("transistor", 2),
Ingredient("cutstone", 4),
Ingredient("charcoal", 3)} ,
RECIPETABS.DRINKS_TAB, 
TECH.SCIENCE_TWO,
nil,
nil,
nil,
nil,
nil,
"images/inventoryimages/kettle_port.xml",
"kettle_port.tex")

if _G.IsDLCEnabled(_G.CAPY_DLC) then

	local water_mahine = Recipe("water_mahine",{ Ingredient("transistor", 2), Ingredient("cutstone", 5), Ingredient("pickaxe", 1)}, RECIPETABS.DRINKS_TAB, TECH.SCIENCE_ONE, RECIPE_GAME_TYPE.COMMON, "water_mahine_placer", 1.6)
	water_mahine.atlas = "images/inventoryimages/water_mahine.xml", "water_mahine.tex"
	
	local ice_mahine = Recipe("ice_mahine",{ Ingredient("transistor", 1), Ingredient("cutstone", 2), Ingredient("heatrock", 1)}, RECIPETABS.DRINKS_TAB, TECH.SCIENCE_ONE, RECIPE_GAME_TYPE.COMMON, "ice_mahine_placer", 1.6)
	ice_mahine.atlas = "images/inventoryimages/ice_mahine.xml", "ice_mahine.tex"
else	
	local water_mahine = Recipe("water_mahine",{ Ingredient("transistor", 2), Ingredient("cutstone", 5), Ingredient("pickaxe", 1)}, RECIPETABS.DRINKS_TAB, TECH.SCIENCE_ONE, "water_mahine_placer", 1.6)
	water_mahine.atlas = "images/inventoryimages/water_mahine.xml", "water_mahine.tex"
	
	local ice_mahine = Recipe("ice_mahine",{ Ingredient("transistor", 1), Ingredient("cutstone", 2), Ingredient("heatrock", 1)}, RECIPETABS.DRINKS_TAB, TECH.SCIENCE_ONE, "ice_mahine_placer", 1.6)
	ice_mahine.atlas = "images/inventoryimages/ice_mahine.xml", "ice_mahine.tex"
end

MakeRecipe( "waterwell_item",
{Ingredient("boards", 2),
Ingredient("cutstone", 5),
Ingredient("pickaxe", 1)} ,
RECIPETABS.DRINKS_TAB, 
TECH.SCIENCE_TWO,
nil,
nil,
nil,
nil,
nil,
"images/inventoryimages/waterwell.xml",
"waterwell.tex")
--[[
MakeRecipe( "cupsjournal",
{Ingredient("papyrus", 2)} ,
RECIPETABS.DRINKS_TAB, 
TECH.SCIENCE_ONE,
nil,
nil,
nil,
nil,
nil,
"images/inventoryimages/cupsjournal.xml",
"cupsjournal.tex")
]]

MakeRecipe( "tee_s",
{Ingredient("tee", 2,"images/inventoryimages/tee.xml")} ,
RECIPETABS.DRINKS_TAB, 
TECH.NONE,
nil,
nil,
nil,
nil,
nil,
"images/water_images.xml",
"tee__s.tex")

MakeRecipe( "tee_m",
{Ingredient("petals_evil", 5)} ,
RECIPETABS.DRINKS_TAB, 
TECH.NONE,
nil,
nil,
nil,
nil,
nil,
"images/water_images.xml",
"tee_m.tex")

MakeRecipe( "tee_r",
{Ingredient("dragonfruit", 1)} ,
RECIPETABS.DRINKS_TAB, 
TECH.NONE,
nil,
nil,
nil,
nil,
nil,
"images/inventoryimages/tee_r.xml",
"tee_r.tex")

MakeRecipe( "tee_r2",
{Ingredient("petals", 7)} ,
RECIPETABS.DRINKS_TAB, 
TECH.NONE,
nil,
nil,
nil,
nil,
nil,
"images/inventoryimages/tee_r.xml",
"tee_r.tex")

MakeRecipe( "cup_strang",
{Ingredient("green_cap", 2) ,
Ingredient("red_cap", 2) ,
Ingredient("cup_water", 1,"images/inventoryimages/cup_water.xml")} ,
RECIPETABS.DRINKS_TAB, 
TECH.NONE,
nil,
nil,
nil,
nil,
nil,
"images/inventoryimages/cup_strang.xml",
"cup_strang.tex")

MakeRecipe( "flour",
{Ingredient("cutwheat", 3,"images/inventoryimages/cutwheat.xml")} ,
RECIPETABS.DRINKS_TAB, 
TECH.SCIENCE_ONE,
nil,
nil,
nil,
nil,
nil,
"images/water_images.xml",
"flour.tex")

if craft_bag == 1 then
MakeRecipe( "grass_bag",
{Ingredient("papyrus", 3),
Ingredient("rope", 2) ,
Ingredient("seeds", 5) ,
Ingredient("turf_forest", 3)} ,
RECIPETABS.DRINKS_TAB, 
TECH.SCIENCE_TWO,
nil,
nil,
nil,
nil,
nil,
"images/water_images.xml",
"grass_bag.tex")
end
